using RuntimeGeneratedFunctions
using Documenter

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force = true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force = true)

makedocs(
    sitename = "RuntimeGeneratedFunctions.jl",
    authors = "Chris Rackauckas",
    modules = [RuntimeGeneratedFunctions],
    clean = true,
    doctest = true,
    linkcheck = true,
    checkdocs = :exports,
    format = Documenter.HTML(
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/RuntimeGeneratedFunctions/stable/"
    ),
    pages = [
        "RuntimeGeneratedFunctions.jl: Efficient Staged Compilation" => "index.md",
        "API" => "api.md",
    ]
)

deploydocs(;
    repo = "github.com/SciML/RuntimeGeneratedFunctions.jl"
)

using Test
using RuntimeGeneratedFunctions, BenchmarkTools
using Serialization

RuntimeGeneratedFunctions.init(@__MODULE__)

# Used by the tests that run a script in a fresh process.
proj = dirname(Base.active_project())
julia = joinpath(Sys.BINDIR, "julia")

function f(_du, _u, _p, _t)
    @inbounds _du[1] = _u[1]
    @inbounds _du[2] = _u[2]
    return nothing
end

ex1 = :(
    (_du, _u, _p, _t) -> begin
        @inbounds _du[1] = _u[1]
        @inbounds _du[2] = _u[2]
        nothing
    end
)

ex2 = :(
    function f(_du, _u, _p, _t)
        @inbounds _du[1] = _u[1]
        @inbounds _du[2] = _u[2]
        return nothing
    end
)

ex3 = :(
    function (_du::T, _u::Vector{E}, _p::P, _t::Any) where {T <: Vector, E, P}
        @inbounds _du[1] = _u[1]
        @inbounds _du[2] = _u[2]
        return nothing
    end
)

f0 = @RuntimeGeneratedFunction(:(() -> 42))
f1 = @RuntimeGeneratedFunction(ex1)
f2 = @RuntimeGeneratedFunction(ex2)
f3 = @RuntimeGeneratedFunction(ex3)

@test f0() === 42

@test f1 isa Function

function evaluate_through_function_interface(f::Function, value)
    return f(value)
end

@test evaluate_through_function_interface(@RuntimeGeneratedFunction(:(x -> x + 1)), 41) == 42

du = rand(2)
u = rand(2)
p = nothing
t = nothing

@test f1(du, u, p, t) === nothing
du == u
du = rand(2)
f2(du, u, p, t)
@test du == u
du = rand(2)
@test f3(du, u, p, t) === nothing
du == u

t1 = @belapsed $f($du, $u, $p, $t)
t2 = @belapsed $f1($du, $u, $p, $t)
t3 = @belapsed $f2($du, $u, $p, $t)
t4 = @belapsed $f3($du, $u, $p, $t)

@test t1 ≈ t2 atol = 3.0e-8
@test t1 ≈ t3 atol = 3.0e-8
@test t1 ≈ t4 atol = 3.0e-8

function no_worldage()
    ex = :(
        function f(_du, _u, _p, _t)
            @inbounds _du[1] = _u[1]
            @inbounds _du[2] = _u[2]
            return nothing
        end
    )
    f1 = @RuntimeGeneratedFunction(ex)
    du = rand(2)
    u = rand(2)
    p = nothing
    t = nothing
    return f1(du, u, p, t)
end
@test no_worldage() === nothing

# Test show()
@test sprint(
    show, MIME"text/plain"(),
    @RuntimeGeneratedFunction(Base.remove_linenums!(:((x, y) -> x + y + 1)))
) ==
    """
    RuntimeGeneratedFunction(#=in $(@__MODULE__)=#, #=using $(@__MODULE__)=#, :((x, y)->begin
              x + y + 1
          end))"""

# Test with precompilation
push!(LOAD_PATH, joinpath(@__DIR__, "precomp"))
using RGFPrecompTest

@test RGFPrecompTest.f(1, 2) == 3
@test RGFPrecompTest.g(40) == 42

# Test that RuntimeGeneratedFunction with identical body expressions (but
# allocated separately) don't clobber each other when one is GC'd.
f_gc = @RuntimeGeneratedFunction(Base.remove_linenums!(:((x, y) -> x + y + 100001)))
let
    @RuntimeGeneratedFunction(Base.remove_linenums!(:((x, y) -> x + y + 100001)))
end
GC.gc()
@test f_gc(1, -1) == 100001

# Test that drop_expr works
f_drop1,
    f_drop2 = let
    ex = Base.remove_linenums!(:(x -> x - 1))
    # Construct two identical RGFs here to test the cache deduplication code
    (
        drop_expr(@RuntimeGeneratedFunction(ex)),
        drop_expr(@RuntimeGeneratedFunction(ex)),
    )
end
GC.gc()
@test f_drop1(1) == 0
@test f_drop2(1) == 0

let
    script = joinpath(@__DIR__, "shared", "drop_expr_specializations.jl")
    trace_file, trace_io = mktemp()
    close(trace_io)
    try
        run(`$julia --startup-file=no --project=$proj --trace-compile=$trace_file $script`)
        specializations = count(eachline(trace_file)) do line
            startswith(
                line, "precompile(Tuple{typeof(RuntimeGeneratedFunctions.drop_expr),"
            )
        end
        @test specializations == 0
    finally
        rm(trace_file; force = true)
    end
end

# Test that threaded use works. Cache reads happen while the caller holds
# Julia's compiler lock, so a cache that blocks there deadlocks instead of
# failing; the subprocess needs a watchdog and more than one thread.
let
    script = joinpath(@__DIR__, "shared", "threaded_rgf.jl")
    proc = run(`$julia --startup-file=no --project=$proj --threads=8 $script`; wait = false)
    watchdog = Timer(_ -> process_running(proc) && kill(proc, Base.SIGKILL), 600)
    try
        wait(proc)
    finally
        close(watchdog)
    end
    @test success(proc)
end

# Test that globals are resolved within the correct scope

module GlobalsTest
    using RuntimeGeneratedFunctions
    RuntimeGeneratedFunctions.init(@__MODULE__)

    y_in_GlobalsTest = 40
    f = @RuntimeGeneratedFunction(:(x -> x + y_in_GlobalsTest))
end

@test GlobalsTest.f(2) == 42

f_outside = @RuntimeGeneratedFunction(GlobalsTest, :(x -> x + y_in_GlobalsTest))
@test f_outside(2) == 42

@test_throws ErrorException @eval(
    module NotInitTest
    using RuntimeGeneratedFunctions
    # RuntimeGeneratedFunctions.init(@__MODULE__) # <-- missing
    f = @RuntimeGeneratedFunction(:(x -> x + y))
    end
)

ex = :(x -> (y -> x + y))
@test @RuntimeGeneratedFunction(ex)(2)(3) === 5

# used to stack overflow due to RGF calling itself, #146
f(x) = x + 1
ex = :(
    function (x)
        return f(x)
    end
)
@test @RuntimeGeneratedFunction(ex)(3) === 4

# used to call the argument tuple instead of the global function, #146
__args(x) = x + 2
ex = :(
    function (x)
        return __args(x)
    end
)
@test @RuntimeGeneratedFunction(ex)(3) === 5

ex = :(x -> (f(y::Int)::Float64 = x + y; f))
@test @RuntimeGeneratedFunction(ex)(2)(3) === 5.0

ex = :(
    x -> function (y::Int)
        return x + y
    end
)
@test @RuntimeGeneratedFunction(ex)(2)(3) === 5

ex = :(
    x -> function f(y::Int)::UInt8
        return x + y
    end
)
@test @RuntimeGeneratedFunction(ex)(2)(3) === 0x05

ex = :(x -> sum(i^2 for i in 1:x))
@test @RuntimeGeneratedFunction(ex)(3) === 14

ex = :(x -> [2i for i in 1:x])
@test @RuntimeGeneratedFunction(ex)(3) == [2, 4, 6]

# Serialization

serialize_script = joinpath(@__DIR__, "shared", "serialize_rgf.jl")
buf = IOBuffer(read(`$julia --startup-file=no --project=$proj $serialize_script`))
deserialized_f, deserialized_g = deserialize(buf)
@test deserialized_f(11) == "Hi from a separate process. x=11"
@test deserialized_f.body isa Expr
@test deserialized_g(12) == "Serialization with dropped body. y=12"
@test deserialized_g.body isa Nothing

# deepcopy
ff = @RuntimeGeneratedFunction(:(x -> [x, x + 1]))
@test deepcopy(ff) == ff
@test deepcopy(ff) === ff

using SciMLTesting

# core_tests.jl must run in `Main` (not an isolated @safetestset module): it
# deserializes RuntimeGeneratedFunctions produced by a separate process whose
# module tag is `Main.#_RGF_ModTag`, so the body must be evaluated where
# `RuntimeGeneratedFunctions.init(@__MODULE__)` initializes `Main`. A thunk runs
# in the caller's (Main) scope; folder-discovery's @safetestset isolation cannot
# express this, so Core is an explicit thunk while QA uses the standard sub-env.
run_tests(;
    core = () -> include(joinpath(@__DIR__, "core_tests.jl")),
    qa = (; env = joinpath(@__DIR__, "qa"), body = joinpath(@__DIR__, "qa", "qa.jl")),
)

module RuntimeGeneratedFunctions

using ExprTools: ExprTools, combinedef, splitdef
using SHA: SHA, SHA1_CTX, update!
using Serialization: Serialization, AbstractSerializer, deserialize

export RuntimeGeneratedFunction, @RuntimeGeneratedFunction, drop_expr

# `init` and `get_expression` are documented, downstream-relied-on entry points
# (see README and the `@autodocs` API page) that are intentionally not exported
# to keep them namespaced under `RuntimeGeneratedFunctions.`. Declare them public
# so downstream packages can qualify-access them and pass ExplicitImports'
# `check_all_qualified_accesses_are_public`.
@static if VERSION >= v"1.11"
    eval(Expr(:public, :init, :get_expression))
end

"""
    RuntimeGeneratedFunction(cache_module, context_module, function_expression;
        opaque_closures = true)

A callable function compiled from `function_expression` without a world-age
barrier. A `RuntimeGeneratedFunction` is a `Function`, so generic code that
accepts and invokes a `Function` can use it. It is not a named generic function:
it represents one callable method and does not participate in method dispatch.

# Arguments

- `cache_module::Module`: module that owns the cached expression. It must have
  been initialized with [`init`](@ref). During precompilation, pass the module
  currently being precompiled so the cache survives precompilation.
- `context_module::Module`: module in which global names in
  `function_expression` are resolved. It must have been initialized with
  [`init`](@ref).
- `function_expression::Expr`: an anonymous-function or function-definition
  expression whose body becomes the callable function.

# Keywords

- `opaque_closures = true`: convert closures and generators in
  `function_expression` to Julia opaque closures. This permits closures in the
  generated body, with Julia's opaque-closure semantics.

# Fields

- `body`: cached body expression while it is retained, or `nothing` after
  [`drop_expr`](@ref). The function remains callable after dropping its local
  expression reference because the cache owns the body.

# Serialization

`Serialization.serialize` preserves a runtime-generated function while its
`body` is retained. Serialize a function before calling [`drop_expr`](@ref): a
dropped function intentionally does not retain the expression needed to restore
its cache in another process.

# Examples

```julia
RuntimeGeneratedFunctions.init(@__MODULE__)
square = RuntimeGeneratedFunction(@__MODULE__, @__MODULE__, :(x -> x^2))
square(3)
```
"""
struct RuntimeGeneratedFunction{argnames, cache_tag, context_tag, id, B} <: Function
    body::B
    function RuntimeGeneratedFunction(cache_tag, context_tag, ex; opaque_closures = true)
        def = splitdef(ex)
        args = normalize_args(get(def, :args, Symbol[]))
        body = def[:body]
        if opaque_closures
            body = closures_to_opaque(body)
        end
        id = expr_to_id(body)
        cached_body = _cache_body(cache_tag, id, body)
        return new{Tuple(args), cache_tag, context_tag, id, typeof(cached_body)}(cached_body)
    end

    # For internal use in deserialize() - doesn't check whether the body is in the cache!
    function RuntimeGeneratedFunction{
            argnames,
            cache_tag,
            context_tag,
            id,
        }(body) where {
            argnames,
            cache_tag,
            context_tag,
            id,
        }
        return new{argnames, cache_tag, context_tag, id, typeof(body)}(body)
    end
end

"""
    drop_expr(rgf::RuntimeGeneratedFunction)

Return a copy of `rgf` that does not retain its function body expression.
This allows the expression AST to be garbage collected while keeping the
function callable.

# Arguments

- `rgf::RuntimeGeneratedFunction`: generated function whose retained expression
  should be released.

# Returns

- A `RuntimeGeneratedFunction` with `body === nothing`. It has the same callable
  behavior as `rgf` while its cache entry remains available.

The expression can still be retrieved later using [`get_expression`](@ref) as long
as at least one `RuntimeGeneratedFunction` with the same body exists.

Serialize a generated function before calling `drop_expr`. A dropped function has
discarded the expression needed to restore its cache in another process.

# Examples
```julia
ex = :((x) -> x^2)
rgf = @RuntimeGeneratedFunction(ex)
rgf_dropped = drop_expr(rgf)
rgf_dropped(2)  # Still works, returns 4
```
"""
function drop_expr(
        ::RuntimeGeneratedFunction{
            a,
            cache_tag,
            c,
            id,
        }
    ) where {
        a, cache_tag, c,
        id,
    }
    # When dropping the reference to the body from an RGF, we need to upgrade
    # from a weak to a strong reference in the cache to prevent the body being
    # GC'd.
    @lock _cache_lock begin
        cache = getfield(parentmodule(cache_tag), _cachename)
        body = cache[id]
        if body isa WeakRef
            cache[id] = body.value
        end
    end
    return RuntimeGeneratedFunction{a, cache_tag, c, id}(nothing)
end

function _check_rgf_initialized(mods...)
    for mod in mods
        if !isdefined(mod, _tagname)
            error(
                """You must use `RuntimeGeneratedFunctions.init(@__MODULE__)` at module
                top level before using runtime generated functions in $mod"""
            )
        end
    end
    return
end

function RuntimeGeneratedFunction(
        cache_module::Module, context_module::Module, code;
        opaque_closures = true
    )
    _check_rgf_initialized(cache_module, context_module)
    return RuntimeGeneratedFunction(
        getfield(cache_module, _tagname),
        getfield(context_module, _tagname),
        code;
        opaque_closures = opaque_closures
    )
end

"""
    @RuntimeGeneratedFunction(function_expression)
    @RuntimeGeneratedFunction(context_module, function_expression,
        opaque_closures = true)

Construct a [`RuntimeGeneratedFunction`](@ref) from a function expression using
the calling module as its cache module. Call [`init`](@ref) at the top level of
that module before expanding this macro.

# Arguments

- `function_expression::Expr`: an anonymous-function or function-definition
  expression to compile.
- `context_module::Module`: optional module in which global names in
  `function_expression` are resolved. By default, names resolve in the calling
  module.

# Keywords

- `opaque_closures = true`: convert closures and generators in the expression to
  Julia opaque closures.

# Examples

```julia
RuntimeGeneratedFunctions.init(@__MODULE__)
increment = @RuntimeGeneratedFunction(:(x -> x + 1))
increment(2)
```
"""
macro RuntimeGeneratedFunction(code)
    return quote
        RuntimeGeneratedFunction(@__MODULE__, @__MODULE__, $(esc(code)))
    end
end
macro RuntimeGeneratedFunction(context_module, code, opaque_closures = true)
    return quote
        RuntimeGeneratedFunction(
            @__MODULE__, $(esc(context_module)), $(esc(code));
            opaque_closures = $(esc(opaque_closures))
        )
    end
end

function Base.show(
        io::IO, ::MIME"text/plain",
        f::RuntimeGeneratedFunction{argnames, cache_tag, context_tag, id}
    ) where {
        argnames,
        cache_tag,
        context_tag,
        id,
    }
    cache_mod = parentmodule(cache_tag)
    context_mod = parentmodule(context_tag)
    func_expr = Expr(:->, Expr(:tuple, argnames...), _lookup_body(cache_tag, id))
    return print(
        io, "RuntimeGeneratedFunction(#=in $cache_mod=#, #=using $context_mod=#, ",
        repr(func_expr), ")"
    )
end

function (f::RuntimeGeneratedFunction)(args::Vararg{Any, N}) where {N}
    return generated_callfunc(f, args...)
end

# We'll generate a method of this function in every module which wants to use
# @RuntimeGeneratedFunction
function generated_callfunc end

function generated_callfunc_body(argnames, cache_tag, id, __args)
    setup = (:($(argnames[i]) = @inbounds __args[$i]) for i in 1:length(argnames))
    body = _lookup_body(cache_tag, id)
    @assert body !== nothing
    return quote
        $(setup...)
        $(body)
    end
end

### Body caching and lookup
#
# Looking up the body of a RuntimeGeneratedFunction based on the id is a little
# complicated because we want the `id=>body` mapping to survive precompilation.
# This means we need to store the mapping created by a module in that module
# itself.
#
# For that, we need a way to lookup the correct module from an instance of
# RuntimeGeneratedFunction. Modules can't be type parameters, but we can use
# any type which belongs to the module as a proxy "tag" for the module.
#
# (We could even abuse `typeof(__module__.eval)` for the tag, though this is a
# little non-robust to weird special cases like Main.eval being
# Base.MainInclude.eval.)

# It appears we can't use a ReentrantLock here, as contention seems to lead to
# deadlock. Perhaps because it triggers a task switch while compiling the
# @generated function.
_cache_lock = Threads.SpinLock()
_cachename = Symbol("#_RuntimeGeneratedFunctions_cache")
_tagname = Symbol("#_RGF_ModTag")

function _cache_body(cache_tag, id, body)
    return lock(_cache_lock) do
        cache = getfield(parentmodule(cache_tag), _cachename)
        # Caching is tricky when `id` is the same for different AST instances:
        #
        # 1. If a function body with the same `id` was cached previously, we need
        # to use that older instance of the body AST as the canonical one
        # rather than `body`. This ensures the lifetime of the body in the
        # cache will always cover the lifetime of all RGFs which share the same
        # `id`.
        #
        # 2. Unless we hold a separate reference to `cache[id].value`, the GC
        # can collect it (causing it to become `nothing`). So root it in a
        # local variable first.
        #
        cached_body = get(cache, id, nothing)
        if !isnothing(cached_body)
            if cached_body isa WeakRef
                # `value` may be nothing here if it was previously cached but GC'd
                cached_body = cached_body.value
            end
        end
        if isnothing(cached_body)
            cached_body = body
            # Use a WeakRef to allow `body` to be garbage collected. (After GC, the
            # cache will still contain an empty entry with key `id`.)
            cache[id] = WeakRef(cached_body)
        end
        return cached_body
    end
end

function _lookup_body(cache_tag, id)
    return lock(_cache_lock) do
        cache = getfield(parentmodule(cache_tag), _cachename)
        body = cache[id]
        body isa WeakRef ? body.value : body
    end
end

"""
    RuntimeGeneratedFunctions.init(mod)

Initialize `mod` for runtime-generated functions.

# Arguments

- `mod::Module`: module that will cache generated expression bodies and own the
  generated call method.

# Rules

Call `init` once at module top level before using
[`@RuntimeGeneratedFunction`](@ref) in `mod`, or before passing `mod` as either
the cache or context module to [`RuntimeGeneratedFunction`](@ref). Repeated calls
are idempotent. Do not call it from a local scope: it defines a generated method
in `mod` so that global names resolve in that module.

# Examples

```julia
module GeneratedFunctionsExample
using RuntimeGeneratedFunctions
RuntimeGeneratedFunctions.init(@__MODULE__)
end
```
"""
function init(mod)
    return lock(_cache_lock) do
        if !isdefined(mod, _cachename)
            mod.eval(
                quote
                    const $_cachename = Dict()
                    struct $_tagname end

                    # We create method of `generated_callfunc` in the user's module
                    # so that any global symbols within the body will be looked up
                    # in the user's module scope.
                    #
                    # This is straightforward but clunky.  A neater solution should
                    # be to explicitly expand in the user's module and return a
                    # CodeInfo from `generated_callfunc`, but it seems we'd need
                    # `jl_expand_and_resolve` which doesn't exist until Julia 1.3
                    # or so. See:
                    #   https://github.com/JuliaLang/julia/pull/32902
                    #   https://github.com/NHDaly/StagedFunctions.jl/blob/master/src/StagedFunctions.jl#L30
                    @inline @generated function $RuntimeGeneratedFunctions.generated_callfunc(
                            f::$RuntimeGeneratedFunctions.RuntimeGeneratedFunction{
                                argnames,
                                cache_tag,
                                $_tagname,
                                id,
                            },
                            __args...
                        ) where {
                            argnames,
                            cache_tag,
                            id,
                        }
                        return $RuntimeGeneratedFunctions.generated_callfunc_body(
                            argnames,
                            cache_tag,
                            id, __args
                        )
                    end
                end
            )
        end
    end
end

###
### Utilities
###
normalize_args(args::Vector) = map(normalize_args, args)
normalize_args(arg::Symbol) = arg
function normalize_args(arg::Expr)
    arg.head === :(::) || error("argument malformed. Got $arg")
    return arg.args[1]
end

function expr_to_id(ex)
    ctx = SHA1_CTX()
    _hash_expr!(ctx, ex)
    return Tuple(reinterpret(UInt32, SHA.digest!(ctx)))
end

_hash_expr!(ctx, ::LineNumberNode) = nothing
const _OPEN = UInt8['(']
const _SEP = UInt8[',']
const _CLOSE = UInt8[')']

function _hash_expr!(ctx, ex::Expr)
    update!(ctx, _OPEN)
    update!(ctx, Vector{UInt8}(string(ex.head)))
    for arg in ex.args
        update!(ctx, _SEP)
        _hash_expr!(ctx, arg)
    end
    return update!(ctx, _CLOSE)
end
_hash_expr!(ctx, ex) = update!(ctx, Vector{UInt8}(string(ex)))

@nospecialize

closures_to_opaque(x, _ = nothing) = x
_tconvert(T, x) = Expr(:(::), Expr(:call, GlobalRef(Base, :convert), T, x), T)
function closures_to_opaque(ex::Expr, return_type = nothing)
    head, args = ex.head, ex.args
    fdef = splitdef(ex; throw = false)
    if fdef !== nothing
        body = get(fdef, :body, nothing)
        if haskey(fdef, :rtype)
            body = _tconvert(fdef[:rtype], closures_to_opaque(body, fdef[:rtype]))
            delete!(fdef, :rtype)
        else
            body = closures_to_opaque(body)
        end
        fdef[:head] = :(->)
        fdef[:body] = body
        name = get(fdef, :name, nothing)
        name !== nothing && delete!(fdef, :name)
        opaque = Expr(:., Expr(:., :Base, QuoteNode(:Experimental)), QuoteNode(Symbol("@opaque")))
        _ex = Expr(:macrocall, opaque, LineNumberNode(0), combinedef(fdef))
        # TODO: emit named opaque closure for better stacktraces
        # (ref https://github.com/JuliaLang/julia/pull/40242)
        if name !== nothing
            name isa Symbol ||
                error("Unsupported function definition `$ex` in RuntimeGeneratedFunction.")
            _ex = Expr(:(=), name, _ex)
        end
        return _ex
    elseif head === :generator
        f_args = Expr(:tuple)
        f_args.args = Any[x.args[1] for x in args[2:end]]
        iters = Any[x.args[2] for x in args[2:end]]
        new_ex = Expr(
            :call, GlobalRef(Base, :Generator),
            closures_to_opaque(Expr(:(->), f_args, args[1]))
        )
        append!(new_ex.args, iters)
        return new_ex
    elseif head === :opaque_closure
        return closures_to_opaque(args[1])
    elseif head === :return && return_type !== nothing
        return Expr(
            :return,
            _tconvert(return_type, closures_to_opaque(args[1], return_type))
        )
    end
    new_ex = Expr(head)
    new_ex.args = Any[closures_to_opaque(x, return_type) for x in args]
    return new_ex
end

"""
    get_expression(rgf::RuntimeGeneratedFunction)

Retrieve the function expression from a `RuntimeGeneratedFunction`.

# Arguments

- `rgf::RuntimeGeneratedFunction`: generated function whose source expression is
  requested.

# Returns

- An anonymous-function `Expr` containing the normalized argument names and the
  cached body.

This works even if [`drop_expr`](@ref) has been called on the function, as long as
the expression is still in the cache (i.e., at least one `RuntimeGeneratedFunction`
with the same body exists).

# Examples
```julia
ex = :((x) -> x^2)
rgf = @RuntimeGeneratedFunction(ex)
RuntimeGeneratedFunctions.get_expression(rgf)
# Returns: :((x,) -> x ^ 2)
```
"""
function get_expression(
        rgf::RuntimeGeneratedFunction{
            argnames, cache_tag,
            context_tag, id, B,
        }
    ) where {
        argnames,
        cache_tag,
        context_tag,
        id,
        B,
    }
    return func_expr = Expr(:->, Expr(:tuple, argnames...), _lookup_body(cache_tag, id))
end

function Serialization.deserialize(
        s::AbstractSerializer,
        ::Type{
            <:RuntimeGeneratedFunction{
                argnames, cache_tag,
                context_tag, id, B,
            },
        }
    ) where {
        argnames,
        cache_tag,
        context_tag,
        id,
        B,
    }
    body = deserialize(s)
    B === Nothing && throw(
        ArgumentError(
            "cannot deserialize a dropped RuntimeGeneratedFunction; serialize it before calling drop_expr"
        )
    )
    cached_body = _cache_body(cache_tag, id, body)
    f = RuntimeGeneratedFunction{argnames, cache_tag, context_tag, id}(cached_body)
    return f
end

# Match Julia functions: runtime-generated functions are immutable callable values.
Base.deepcopy(f::RuntimeGeneratedFunction) = f

@specialize

end

# Must be run in a separate process from the rest of the tests!

using RuntimeGeneratedFunctions
using Serialization

RuntimeGeneratedFunctions.init(@__MODULE__)

f = @RuntimeGeneratedFunction(:(x -> "Hi from a separate process. x=$x"))
g = drop_expr(@RuntimeGeneratedFunction(:(y -> "Serialization with dropped body. y=$y")))

serialize(stdout, (f, g))

module RGFPrecompTest
using RuntimeGeneratedFunctions
using RGFPrecompTest2
RuntimeGeneratedFunctions.init(@__MODULE__)

f = @RuntimeGeneratedFunction(:((x, y) -> x + y))

g = RGFPrecompTest2.generate_rgf(@__MODULE__)
end

module RGFPrecompTest2
using RuntimeGeneratedFunctions
RuntimeGeneratedFunctions.init(@__MODULE__)

y_in_RGFPrecompTest2 = 2

# Simulates a helper function which generates an RGF, but caches it in a
# different module.
function generate_rgf(cache_module)
    context_module = @__MODULE__
    return RuntimeGeneratedFunction(cache_module, @__MODULE__, :((x) -> y_in_RGFPrecompTest2 + x))
end
end

# Construct and call RuntimeGeneratedFunctions from several threads at once.
# Run as a subprocess by core_tests.jl because the failure mode it guards
# against is a hang rather than a wrong answer, and it needs more than one
# thread to show up.

using RuntimeGeneratedFunctions
RuntimeGeneratedFunctions.init(@__MODULE__)

tasks = map(1:max(4, Threads.nthreads())) do k
    Threads.@spawn begin
        for i in 1:100
            f = @RuntimeGeneratedFunction(
                Base.remove_linenums!(:((x, y) -> x + y + $i * $k))
            )
            f(1, 2) == 3 + i * k || error("wrong result for i=$i, k=$k")
        end
    end
end
foreach(fetch, tasks)

# Public API

```@docs
RuntimeGeneratedFunction
@RuntimeGeneratedFunction
drop_expr
```

# Setup and Inspection API

```@docs
RuntimeGeneratedFunctions.init
RuntimeGeneratedFunctions.get_expression
```

# RuntimeGeneratedFunctions.jl: Generate functions at runtime

`RuntimeGeneratedFunctions` are functions generated at runtime without world-age
issues and with the full performance of a standard Julia anonymous function. This
builds functions in a way that avoids `eval`.

Note that `RuntimeGeneratedFunction` does not handle closures. Please use the
[GeneralizedGenerated.jl](https://github.com/JuliaStaging/GeneralizedGenerated.jl)
package for more flexible staged programming. While `GeneralizedGenerated.jl` is
more powerful, `RuntimeGeneratedFunctions.jl` handles large expressions better.

## Tutorials and Documentation

For information on using the package,
[see the stable documentation](https://docs.sciml.ai/RuntimeGeneratedFunctions/stable/). Use the
[in-development documentation](https://docs.sciml.ai/RuntimeGeneratedFunctions/dev/) for the version of
the documentation, which contains the unreleased features.

## Simple Example

Here's an example showing how to construct and immediately call a runtime
generated function:

```julia
using RuntimeGeneratedFunctions
RuntimeGeneratedFunctions.init(@__MODULE__)

function no_worldage()
    ex = :(function f(_du, _u, _p, _t)
        @inbounds _du[1] = _u[1]
        @inbounds _du[2] = _u[2]
        nothing
    end)
    f1 = @RuntimeGeneratedFunction(ex)
    du = rand(2)
    u = rand(2)
    p = nothing
    t = nothing
    f1(du, u, p, t)
end
no_worldage()
```

## Changing how global symbols are looked up

If you want to use helper functions or global variables from a different
module within your function expression, you'll need to pass a `context_module`
to the `@RuntimeGeneratedFunction` constructor. For example:

```julia
RuntimeGeneratedFunctions.init(@__MODULE__)

module A
using RuntimeGeneratedFunctions
RuntimeGeneratedFunctions.init(A)
helper_function(x) = x + 1
end

function g()
    expression = :(f(x) = helper_function(x))
    # context module is `A` so that `helper_function` can be found.
    f = @RuntimeGeneratedFunction(A, expression)
    @show f(1)
end
```

## Precompilation and setting the function expression cache

For technical reasons, RuntimeGeneratedFunctions needs to cache the function
expression in a global variable within some module. This is normally
transparent to the user, but if the `RuntimeGeneratedFunction` is evaluated
during module precompilation, the cache module must be explicitly set to the
module currently being precompiled. This is relevant for helper functions in
some module which constructs a RuntimeGeneratedFunction on behalf of the user.
For example, in the following code, any third party user of
`HelperModule.construct_rgf()` needs to pass their own module as the
`cache_module` if they want the returned function to work after precompilation:

```julia
RuntimeGeneratedFunctions.init(@__MODULE__)

# Imagine HelperModule is in a separate package and will be precompiled
# separately.
module HelperModule
using RuntimeGeneratedFunctions
RuntimeGeneratedFunctions.init(HelperModule)

function construct_rgf(cache_module, context_module, ex)
    ex = :((x) -> $ex^2 + x)
    RuntimeGeneratedFunction(cache_module, context_module, ex)
end
end

function g()
    ex = :(x + 1)
    # Here cache_module is set to the module currently being compiled so that
    # the returned RGF works with Julia's module precompilation system.
    HelperModule.construct_rgf(@__MODULE__, @__MODULE__, ex)
end

f = g()
@show f(1)
```

## Retrieving Expressions

From a constructed RuntimeGeneratedFunction, you can retrieve the expressions using the
`RuntimeGeneratedFunctions.get_expression` command. For example:

```julia
ex = :((x) -> x^2)
rgf = @RuntimeGeneratedFunction(ex)
julia> RuntimeGeneratedFunctions.get_expression(rgf)
:((x,) -> x ^ 2)
```

This can be used to get the expression even if `drop_expr` has been performed.

### Example: Retrieving Expressions from ModelingToolkit.jl

[ModelingToolkit.jl](https://github.com/SciML/ModelingToolkit.jl) uses
RuntimeGeneratedFunctions.jl for the construction of its functions to avoid issues of
world-age. Take for example its tutorial:

```julia
using ModelingToolkit, RuntimeGeneratedFunctions
using ModelingToolkit: t_nounits as t, D_nounits as D

@mtkmodel FOL begin
    @parameters begin
        τ # parameters
    end
    @variables begin
        x(t) # dependent variables
    end
    @equations begin
        D(x) ~ (1 - x) / τ
    end
end

using DifferentialEquations: solve
@mtkbuild fol = FOL()
prob = ODEProblem(fol, [fol.x => 0.0], (0.0, 10.0), [fol.τ => 3.0])
```

If we check the function:

```julia
julia> prob.f
(::ODEFunction{true, SciMLBase.AutoSpecialize, ModelingToolkit.var"#f#697"{RuntimeGeneratedFunction{(:ˍ₋arg1, :ˍ₋arg2, :t), ModelingToolkit.var"#_RGF_ModTag", ModelingToolkit.var"#_RGF_ModTag", (0x2cce5cf2, 0xd20b0d73, 0xd14ed8a6, 0xa4d56c4f, 0x72958ea1), Nothing}, RuntimeGeneratedFunction{(:ˍ₋out, :ˍ₋arg1, :ˍ₋arg2, :t), ModelingToolkit.var"#_RGF_ModTag", ModelingToolkit.var"#_RGF_ModTag", (0x7f3c227e, 0x8f116bb1, 0xb3528ad5, 0x9c57c605, 0x60f580c3), Nothing}}, UniformScaling{Bool}, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, ModelingToolkit.var"#852#generated_observed#706"{Bool, ODESystem, Dict{Any, Any}, Vector{Any}}, Nothing, ODESystem, Nothing, Nothing}) (generic function with 1 method)
```

It's a RuntimeGeneratedFunction. We can find the code for this system using the retrieval
command on the function we want. For example, for the in-place function:

```julia
julia> RuntimeGeneratedFunctions.get_expression(prob.f.f.f_iip)

:((ˍ₋out, ˍ₋arg1, ˍ₋arg2, t)->begin
          #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:373 =#
          #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:374 =#
          #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:375 =#
          begin
              begin
                  begin
                      #= C:\Users\accou\.julia\packages\Symbolics\HIg7O\src\build_function.jl:546 =#
                      #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:422 =# @inbounds begin
                              #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:418 =#
                              ˍ₋out[1] = (/)((+)(1, (*)(-1, ˍ₋arg1[1])), ˍ₋arg2[1])
                              #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:420 =#
                              nothing
                          end
                  end
              end
          end
      end)
```

or the out-of-place function:

```julia
julia> RuntimeGeneratedFunctions.get_expression(prob.f.f.f_oop)
:((ˍ₋arg1, ˍ₋arg2, t)->begin
          #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:373 =#
          #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:374 =#
          #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:375 =#
          begin
              begin
                  begin
                      #= C:\Users\accou\.julia\packages\SymbolicUtils\c0xQb\src\code.jl:468 =#
                      (SymbolicUtils.Code.create_array)(typeof(ˍ₋arg1), nothing, Val{1}(), Val{(1,)}(), (/)((+)(1, (*)(-1, ˍ₋arg1[1])), ˍ₋arg2[1]))
                  end
              end
          end
      end)
```

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```
